/**
 * bVLineArray
 */

/**
 * @author yousuke
 *
 */

import javax.media.j3d.LineArray;
import javax.media.j3d.Shape3D;
import javax.media.j3d.BranchGroup;
import javax.vecmath.Point3d;
import javax.vecmath.Color3f;

public class Mesh extends BranchGroup{
	public Mesh(double dsize,int lineLength){
		//point1s.length
		LineArray lines = new LineArray((lineLength+1)*4, LineArray.COORDINATES | LineArray.COLOR_3);

		Point3d[] point1s = new Point3d[(lineLength+1)*4];
		for(int i=0;i<=lineLength;i++){
			point1s[i*4]   = new Point3d(-lineLength*dsize/2.0+i*dsize,0,-lineLength*dsize/2.0);
			point1s[i*4+1] = new Point3d(-lineLength*dsize/2.0+i*dsize,0,+lineLength*dsize/2.0);
			point1s[i*4+2] = new Point3d(-lineLength*dsize/2.0,0,-lineLength*dsize/2.0+i*dsize);
			point1s[i*4+3] = new Point3d(+lineLength*dsize/2.0,0,-lineLength*dsize/2.0+i*dsize);
		}
		
	
		lines.setCoordinates(0, point1s);

		Color3f blue = new Color3f(0,0,1);
		for(int i=0;i<point1s.length;i++){
			lines.setColor(i,blue);
		}
		
		Shape3D shape = new Shape3D(lines);

		this.addChild(shape);
		this.setUserData("Mesh");
	}


}


















/*
import javax.media.j3d.LineArray;
import javax.media.j3d.Shape3D;
import javax.media.j3d.BranchGroup;
import javax.vecmath.Point3d;
import javax.vecmath.Color3f;

public class Mesh extends BranchGroup{
	public Mesh(double dsize,int lineLength){
		//point1s.length
		
		
		Color3f blue = new Color3f(0,0,1);

		for(int i=0;i<=lineLength;i++){
			Point3d[] pointZ = new Point3d[2];
			LineArray lineZ = new LineArray(2,LineArray.COORDINATES | LineArray.COLOR_3);
			pointZ[0]   = new Point3d(-lineLength*dsize/2.0+i*dsize,0,-lineLength*dsize/2.0);
			pointZ[1] = new Point3d(-lineLength*dsize/2.0+i*dsize,0,+lineLength*dsize/2.0);
			lineZ.setCoordinates(0,pointZ);
			for(int j=0;j<pointZ.length;j++){
				lineZ.setColor(j,blue);
			}
			this.addChild(new Shape3D(lineZ));

			Point3d[] pointX = new Point3d[2];
			LineArray lineX = new LineArray(2,LineArray.COORDINATES | LineArray.COLOR_3);
			pointX[0] = new Point3d(-lineLength*dsize/2.0,0,-lineLength*dsize/2.0+i*dsize);
			pointX[1] = new Point3d(+lineLength*dsize/2.0,0,-lineLength*dsize/2.0+i*dsize);
			lineX.setCoordinates(0,pointX);
			for(int j=0;j<pointX.length;j++){
				lineX.setColor(j,blue);
			}
			this.addChild(new Shape3D(lineX));
		}
	}


}
*/