
import java.applet.*;
import java.awt.*;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;

import javax.media.j3d.*;
import jp.ac.nagoya_cu.sda.paper.*;
import jp.ac.nagoya_cu.sda.paper.behavior.*;
import com.sun.j3d.utils.universe.PlatformGeometry;
import com.sun.j3d.utils.universe.SimpleUniverse;
import javax.vecmath.*;
import com.sun.j3d.utils.behaviors.keyboard.*;

@SuppressWarnings("serial")
public class Origami extends Applet{

	public Origami(){
		set();
	}
	
	
	private void removeCanvas(){
		System.out.println("Zbg");
		this.removeAll();
	}
	
	private void set(){
		GraphicsConfiguration config = SimpleUniverse.getPreferredConfiguration();
		Canvas3DwithFPS canvas = new Canvas3DwithFPS(config);
 		this.setLayout(new BorderLayout());
		this.add(canvas, BorderLayout.CENTER);
		this.doLayout();//Zbg̎ɌĂ΂Ȃcabvas\Ȃ

		//Zbgǉ
		canvas.addKeyListener(new KeyAdapter(){
			public void keyReleased(KeyEvent kevt){
				if(kevt.getKeyCode() == KeyEvent.VK_ESCAPE){
					removeCanvas();
					set();
				}
			}
		});
		
		SimpleUniverse universe = new SimpleUniverse(canvas);
		
		//_KɈړ
		universe.getViewingPlatform().setNominalViewingTransform();

		
		BranchGroup scene = createSceneGraph(canvas);
		universe.addBranchGraph(scene);
	}
	
	private BranchGroup createSceneGraph(Canvas3DwithFPS canvas){
		BranchGroup root = new BranchGroup();
		
		//uSEv𓮂̂ɎgWϊ
		TransformGroup roottrans = new TransformGroup();
		roottrans.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
		roottrans.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
		
		
		
		BoundingSphere bounds = new BoundingSphere( new Point3d(), 100.0 );

		// uv쐬
		Paper paper = new Paper(1.2,1.2,this);
		//}EXǉ
		FoldingBehavior folding = new FoldingBehavior(canvas, paper,roottrans, bounds);
		paper.addChild(folding);
		
		//Փ˔
		solveCollisionBehavior collision=new solveCollisionBehavior(paper,bounds);
		paper.addChild(collision);
		
		
		

		//𕽂ɂ
		PressBehavior press = new PressBehavior(paper, bounds);
		paper.addChild(press);

		//𕽂ɂ
		UndoBehavior undo = new UndoBehavior(paper, bounds);
		paper.addChild(undo);

		// Wϊ
		TransformGroup transOrigami = new TransformGroup();
		transOrigami.addChild(paper);
		transOrigami.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
		transOrigami.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
		transOrigami.setCapability(TransformGroup.ALLOW_LOCAL_TO_VWORLD_READ);
				
		roottrans.addChild(transOrigami);
		
		
		// SE𓮂rwCrA
		KeyNavigatorBehavior keybehavior = new KeyNavigatorBehavior (roottrans);
		keybehavior.setSchedulingBounds(bounds);
		root.addChild(keybehavior);
		RotateCanvasBehavior rootbehavior = new RotateCanvasBehavior(canvas,roottrans);
		rootbehavior.setSchedulingBounds(bounds);
		rootbehavior.addExceptBranchGroup(paper);	// Paper͏O
		root.addChild(rootbehavior);
		
		
		// SEɃbVǉ
		//roottrans.addChild(new Mesh(0.1d,20));

		
		// ǉ
		Vector3f ld=new Vector3f(-.5f,-.5f,-1);
		DirectionalLight light = new DirectionalLight(new Color3f(1,1,1),ld);
		light.setInfluencingBounds(bounds);
		root.addChild(light);
		AmbientLight aml=new AmbientLight();
		aml.setInfluencingBounds(bounds);
		root.addChild(aml);
		
		//}EXǉ
		createFoldingLineBehavior createfolding = new createFoldingLineBehavior(canvas, root, bounds);
		createfolding.setPaper(paper);
		root.addChild(createfolding);

		// wi
		Background bg = new Background(new Color3f(.6f,.6f,.6f));
		bg.setApplicationBounds(bounds);
		root.addChild(bg);

		//X^[g̃Aj[V
		Alpha alpha=new Alpha(1,2000);
		alpha.setStartTime(System.currentTimeMillis()+100);
		root.addChild(createStartupInterpolator(bounds,alpha,roottrans));
		
		//t[[g
//		PlatformGeometry pg=new PlatformGeometry();
//		FrameRateBehavior fr=new FrameRateBehavior(canvas,pg,bounds);
//		universe.getViewingPlatform().setPlatformGeometry(pg);
//		root.addChild(fr);
		
		
		root.addChild(roottrans);
		
		return root;
	}
	
	public Interpolator createStartupInterpolator(Bounds bounds,Alpha alpha,TransformGroup target){
		int len=50;
		
		float startArg=(float)(-180f/180f*Math.PI*7);
		float endArg=0;
		float startAxArg=(float)(-360f/180f*Math.PI*1);
		float endAxArg=0;
		
		AxisAngle4d ax=new AxisAngle4d();
		AxisAngle4d axZ=new AxisAngle4d();
		ax.x=0;ax.y=1;ax.z=0;
		
		Vector3d vax=new Vector3d(1,0,0);
		vax.normalize();
		axZ.x=vax.x;axZ.y=vax.y;ax.z=vax.z;
		Quat4f qax=new Quat4f();

		float[] knots=new float[len+1];
		Quat4f[] quats=new Quat4f[len+1];
		
		for(int i=0;i<=len;i++){
			knots[i]=1f/len*(i);
			ax.angle=startArg+(endArg-startArg)*(Math.pow(1f/len*i,1/5d));
			axZ.angle=startAxArg+(endAxArg-startAxArg)*(Math.pow(1f/len*i,1/2.8d));
			qax.set(axZ);
			
			Quat4f quat=new Quat4f();
			quat.set(ax);
			//quat.mul(qax);
			quats[i]=quat;
		}
		
		Interpolator it=new RotationPathInterpolator(alpha,target,new Transform3D(),knots,quats);
		it.setSchedulingBounds(bounds);
		return it;
	}
	
	
	public static void main(String[] args) {
		Origami applet = new Origami();
		MainFrame frame=new MainFrame(applet,500,400);
		//com.sun.j3d.utils.applet.MainFrame frame=new com.sun.j3d.utils.applet.MainFrame(applet,500,400);
		
	}

	
}
