package jp.ac.nagoya_cu.sda.paper;

/**
 * NX
 */

/**
 * @author yousuke
 *
 */

import javax.vecmath.*;

import jp.ac.nagoya_cu.sda.paper.shape.LineShape;

public abstract class Line {
	protected VertexPoint pa,pb;
	protected LineShape lshape=null;
	protected static int cntall = 0;	// IuWFNǧi[
	protected int cnt = 0;	// IuWFNgڂɐꂽi[
	protected double rlength;	// ̗_li[

	public Line(VertexPoint pntStart, VertexPoint pntEnd){
		pa = pntStart;
		pb = pntEnd;
		
		rlength = pb.distance(pa);

		cnt=cntall;
		cntall++;
	}
	
	/**
	 * IuWFNgƗ^ꂽ_Ƃ̊Ԃ̋Ԃ
	 * @return
	 */
	public double distance(Point3d pfrom){
		return distance(pa,pb,pfrom);
	}
	public static double distance(Point3d pstart,Point3d pend,Point3d pfrom){
		Vector3d v = new Vector3d(pend);
		v.sub(pstart);
		
		Vector3d p = new Vector3d(pfrom);
		p.sub(pstart);
		
		double k = v.dot(p);
		if(0 <= k && k <= v.lengthSquared()){
			Vector3d ps = new Vector3d(p);
			v.normalize();
			v.scale(v.dot(p));
			ps.sub(v);
			return ps.length();
		}
		else if(k < 0){
			return p.length();
		}
		else{
			Vector3d ps = new Vector3d(pfrom);
			ps.sub(pend);
			return ps.length();
		}
	}

	/**
	 * ōł߂_̍WԂ
	 */
	public Point3d closestPoint(Point3d pfrom){
		return closestPoint(pa,pb,pfrom);
	}
	public static Point3d closestPoint(Point3d pa,Point3d pb,Point3d pfrom){
		
		if(pa.equals(pb)){
			return pa;
		}
		
		Vector3d v=new Vector3d();
		v.sub(pb,pa);
		v.normalize();
		
		Vector3d toP=new Vector3d();
		toP.sub(pfrom,pa);
		
		double dot=v.dot(toP);
		if(dot<0){
			return pa;
		}
		else if(dot>pa.distance(pb)){
			return pb;
		}
		
		v.scaleAdd(dot,v,pa);
		return new Point3d(v);

	}
	
	/**
	 * _܂ޒōł߂_̍WԂ
	 */
	public Point3d closestPointOnLine(Point3d pfrom){
		return closestPointOnLine(pa,pb,pfrom);
	}
	public static Point3d closestPointOnLine(Point3d pa,Point3d pb,Point3d pfrom){
		if(pa.equals(pb)){
			return pa;
		}
		
		Vector3d v=new Vector3d();
		v.sub(pb,pa);
		v.normalize();
		
		Vector3d toP=new Vector3d();
		toP.sub(pfrom,pa);
		
		double dot=v.dot(toP);
		
		v.scaleAdd(dot,v,pa);
		return new Point3d(v);

	}
	
	public VertexPoint getPointA(){
		return pa;
	}
	public VertexPoint getPointB(){
		return pb;
	}
	public void getDirection(Vector3d vD){
		vD.sub(pb,pa);
	}
	public void getStartPoint(Point3d p){
		p.set(pa);
	}
	public Vector3d createDirection(){
		Vector3d v=new Vector3d();
		v.sub(pb,pa);
		return v;
	}
	public Point3d createStartPoint(){
		return new Point3d(pa);
	}
	
	/**
	 * ̈ʒum肽ƂɎg֐
	 * @return
	 */
	public Point3d getPos(){
		Point3d p = new Point3d();
		p.add(pa,pb);
		p.scale(1d/2d);
		return p;
	}
	
	/**
	 * IuWFNgێ_̂A^ꂽ_pł͂Ȃ̓_Ԃ
	 * @param p
	 * @return pێ_̂̂ǂ炩ł΂ȊO̓_B
	 * pǂłȂnull
	 */
	public VertexPoint getAnotherPoint(VertexPoint p){
		if(pa==p){
			return pb;
		}else if(pb==p){
			return pa;
		}
		return null;
	}
	
	public boolean contain(VertexPoint vp){
		if(pa==vp){
			return true;
		}else if(pb==vp){
			return true;
		}else{
			return false;
		}
	}

	/**
	 * ̎ۂ̒B
	 * [̊ԊuԂB
	 */
	public double length(){
		return pa.distance(pb);
	}
	
	/**
	 * ̗_IȒԂB
	 * _l̓CX^X̐Ɍ肳AύX邱Ƃ͂ȂB
	 */
	public double lengthTheoretical(){
		return rlength;
	}
	
	public double getErrorMargin(){
		return length()-lengthTheoretical();
	}

	
	
	
	
	public void setLineShape(LineShape lshape){
		this.lshape=lshape;
	}
	
	
	
	public LineShape getLineShape(){
		return this.lshape;
	}
	
//	public String getID(){
//		return this.getClass().getSimpleName() + "["+cnt+"]";
//	}
	public String toString(){
		return pa.toString() + "-" + pb.toString();
	}
}
