package jp.ac.nagoya_cu.sda.paper;

import java.util.*;

import javax.media.j3d.GeometryArray;
import javax.vecmath.Point2d;
import javax.vecmath.Point3d;
import javax.vecmath.TexCoord2f;

import com.sun.j3d.utils.geometry.GeometryInfo;
import com.sun.j3d.utils.geometry.NormalGenerator;

@SuppressWarnings("serial")
public class PlaneGeometry{

	List<Line> lines=null;
	List<Triangle> trs=null;
	
	public PlaneGeometry(Collection<Line> lines){
		this.lines=new ArrayList<Line>(lines);
		trs=createTriangle();
	}

	public List<Line> getAllLine(){
		return Collections.unmodifiableList(lines);
	}
	
	public Line getRinged(int indexRinged){
		int i=0;
		while(indexRinged<0 && i++< 50){
			//System.out.println(indexRinged+" "+size());
			indexRinged += lines.size();
		}
		return lines.get(indexRinged%lines.size());
	}
	
	public boolean lineDirection(int indexRinged){
		Line beforeln=getRinged(indexRinged-1);
		Line ln=getRinged(indexRinged);
		if(beforeln.contain(ln.getPointA())){
			return true;
		}else if(beforeln.contain(ln.getPointB())){
			return false;
		}else{
			System.out.println("ӂȂĂȂII");
			return false;
		}
	}
	
	public VertexPoint getLineStartVertex(int indexRinged){
		if(lineDirection(indexRinged)){
			return getRinged(indexRinged).pa;
		}else{
			return getRinged(indexRinged).pb;
		}
	}
	
	public VertexPoint[] getAllVertexPoints(){
		VertexPoint[] vp = new VertexPoint[lines.size()];
		
		for(int i=0;i<lines.size();i++){
			if(lineDirection(i)){
				vp[i]=lines.get(i).getPointA();
			}else{
				vp[i]=lines.get(i).getPointB();
			}
		}
		return vp;
	}
	
	/**
	 * Geometry𐶐
	 * @return
	 */
	protected GeometryArray createGeometry(){
		VertexPoint[] vertices=getAllVertexPoints();
		if(vertices.length < 3){
			System.out.println("ӂ̖{͂R{ȏȂƂ");
			throw new java.lang.IllegalArgumentException();
		}

		int[] stripVertexCounts = { vertices.length };
		GeometryInfo ginfo = new GeometryInfo(GeometryInfo.TRIANGLE_FAN_ARRAY);
		ginfo.setCoordinates(vertices);
		ginfo.setStripCounts(stripVertexCounts);

		//eNX`W
		TexCoord2f[] texPts=new TexCoord2f[vertices.length];
		for(int i=0;i<vertices.length;i++){
			Point2d f=vertices[i].getPoint2D();
			texPts[i]=new TexCoord2f((float)f.x,(float)f.y);
		}
		ginfo.setTextureCoordinateParams(1,2);
		ginfo.setTextureCoordinates(0,texPts);

		
		// @
		NormalGenerator gen = new NormalGenerator();
		gen.generateNormals(ginfo);

		// WIg[
		GeometryArray geometry = ginfo.getGeometryArray();
		geometry.setCapability(GeometryArray.ALLOW_INTERSECT);
		geometry.setCapability(GeometryArray.ALLOW_COORDINATE_READ);
		geometry.setCapability(GeometryArray.ALLOW_COUNT_READ);
		geometry.setCapability(GeometryArray.ALLOW_FORMAT_READ);
		geometry.setCapability(GeometryArray.ALLOW_NORMAL_READ);

		return geometry;
	}
	
	public GeometryArray getGeometry(){
		return createGeometry();
	}
	
	protected List<Triangle> createTriangle(){
		//TriangleFanArrayƂTriangle𐶐
		LinkedList<Triangle> list = new LinkedList<Triangle>();
		VertexPoint[] vps = getAllVertexPoints();
		for (int i = 2; i < vps.length; i++) {
			Point3d[] tr = new Point3d[3];
			tr[0] = vps[0];
			tr[1] = vps[i - 1];
			tr[2] = vps[i];
			list.add(new Triangle(tr));
		}
		return list;
	}
	
	public List<Triangle> getTriangleList(){
		return Collections.unmodifiableList(trs);
	}
	public boolean containTriangle(Triangle tr){
		return trs.contains(tr);
	}
	
	
}
