package jp.ac.nagoya_cu.sda.paper.behavior;

import java.awt.Font;
import java.util.Enumeration;
import javax.media.j3d.*;
import javax.vecmath.Color3f;
import javax.vecmath.Vector3d;

import jp.ac.nagoya_cu.sda.paper.Canvas3DwithFPS;

import com.sun.j3d.utils.geometry.Text2D;

public class FrameRateBehavior extends Behavior{

	protected WakeupOnElapsedFrames wup=null;
	private int skipFrame=10;
	protected Text2D text=null;
	Canvas3DwithFPS canvas=null;
	
	public FrameRateBehavior(Canvas3DwithFPS canvas,Group gr,Bounds bounds){
		super();
		Text2D t2d=new Text2D("  ",new Color3f(1,1,1),"Monospaced",12,Font.BOLD);
		t2d.setCapability(Text2D.ALLOW_APPEARANCE_READ);
		t2d.setCapability(Text2D.ALLOW_APPEARANCE_WRITE);
		t2d.getAppearance().setCapability(Appearance.ALLOW_TEXTURE_READ);
		t2d.getAppearance().setCapability(Appearance.ALLOW_TEXTURE_WRITE);
		
		Transform3D t3d=new Transform3D();
		t3d.set(new Vector3d(0.35,0.25,-1));
		//t3d.rotX(Math.PI/2d);
		TransformGroup tg=new TransformGroup(t3d);
		
		tg.addChild(t2d);
		gr.addChild(tg);
		this.text=t2d;
		
		setSchedulingBounds(bounds);
		wup=new WakeupOnElapsedFrames(skipFrame);
		
		this.canvas=canvas;
	}
	public void initialize() {
		wakeupOn(wup);
	}

	public void processStimulus(Enumeration arg0) {
		text.setString(Integer.toString(canvas.getFPS()));
		wakeupOn(wup);
	}
}
