package jp.ac.nagoya_cu.sda.paper.behavior;
/*
 * com.sun.j3d.utils.behaviors.mouse.MouseRotate 
 * sbN֘ȀǉrwCrA
 * 
 */


import com.sun.j3d.utils.picking.*;
import java.awt.event.*;
import java.util.*;
import javax.media.j3d.*;
import javax.vecmath.*;


public class RotateCanvasBehavior extends MouseBehavior {
	protected double x_angle, y_angle;
	protected double x_factor = .03;
	protected double y_factor = .03;
	
	protected int x,y;
	protected int x_last,y_last;
	
	protected ArrayList<PickCanvas> Except = new ArrayList<PickCanvas>();
	protected Canvas3D canvas;
	protected boolean isRotatable = false;
	protected TransformGroup transformGroup=null;
	protected Transform3D transformX=new Transform3D();
	protected Transform3D transformY=new Transform3D();
	protected Transform3D currXform=new Transform3D();

	
	public RotateCanvasBehavior(Canvas3D canvas,TransformGroup transformGroup) {
		this.transformGroup=transformGroup;
		this.canvas=canvas;
	}
	
	public void addExceptBranchGroup(BranchGroup ExceptGroup){
		PickCanvas pCanvas=new PickCanvas(canvas,ExceptGroup);
		Except.add(pCanvas);
	}
	


	
	
	public void onMousePressed(MouseEvent mevent){
		x_last = mevent.getX();
		y_last = mevent.getY();
		if(getMouseButtonStatus(mevent)==MouseEvent.BUTTON2_DOWN_MASK){
			isRotatable = true;
		}
	}
	public void onMouseReleased(MouseEvent mevent){
		isRotatable = false;
	}
	public void onMouseDragged(MouseEvent mevent){
		doProcessA(mevent);
	}


	
	void doProcessA(MouseEvent evt) {
		int dx, dy;

		if (isRotatable) {
			x = evt.getX();
			y = evt.getY();

			dx = x - x_last;
			dy = y - y_last;

			x_angle = dy * y_factor;
			y_angle = dx * x_factor;

			transformX.rotX(x_angle);
			transformY.rotY(y_angle);

			transformGroup.getTransform(currXform);

			Matrix4d mat = new Matrix4d();
			// Remember old matrix
			currXform.get(mat);

			// Translate to origin
			currXform.setTranslation(new Vector3d(0.0, 0.0, 0.0));
			currXform.mul(transformX, currXform);
			currXform.mul(transformY, currXform);

			// Set old translation back
			Vector3d translation = new Vector3d(mat.m03, mat.m13, mat.m23);
			currXform.setTranslation(translation);

			// Update xform
			transformGroup.setTransform(currXform);

			x_last = x;
			y_last = y;
		}
	}

	
	boolean hasPickableObject(int x,int y){
		Iterator<PickCanvas> it=Except.iterator();
		while(it.hasNext()){
			PickCanvas pCanvas = it.next();
			pCanvas.setMode(PickTool.GEOMETRY);
			pCanvas.setShapeLocation(x,y);
			if(pCanvas.pickClosest() != null){
				return true;
			}
		}
		return false;
	}
}

