package jp.ac.nagoya_cu.sda.paper.behavior;

import java.awt.AWTEvent;
import java.awt.event.KeyEvent;
import java.util.Enumeration;

import javax.media.j3d.Behavior;
import javax.media.j3d.Bounds;
import javax.media.j3d.WakeupCriterion;
import javax.media.j3d.WakeupOnAWTEvent;
import javax.media.j3d.WakeupOr;
import jp.ac.nagoya_cu.sda.paper.Paper;

public class UndoBehavior extends Behavior{

	protected Paper paper=null;
	protected WakeupOr wakeupCondition;
	
	public UndoBehavior(Paper paper,Bounds bounds){
		setSchedulingBounds(bounds);
		this.paper=paper;
	}

	public void initialize() {
		WakeupCriterion[] wk=new WakeupCriterion[2];
		wk[0] = new WakeupOnAWTEvent(KeyEvent.KEY_PRESSED);
		wk[1] = new WakeupOnAWTEvent(KeyEvent.KEY_RELEASED);
		wakeupCondition=new WakeupOr(wk); 
		wakeupOn(wakeupCondition);
	}


	public void processStimulus(Enumeration criteria) {
		WakeupOnAWTEvent wevent = null;
		AWTEvent[] events = null;
		while (criteria.hasMoreElements()) {
			wevent = (WakeupOnAWTEvent) criteria.nextElement();
			events = wevent.getAWTEvent();
			for (int i = 0; i < events.length; i++) {
				AWTEvent event=events[i];
				
				if (events[i] instanceof KeyEvent) {
					if (event.getID() == KeyEvent.KEY_PRESSED) {
						int code = ((KeyEvent) events[i]).getKeyCode();
						switch (code) {
						case KeyEvent.VK_Z:
							undo();
							break;
						case KeyEvent.VK_Y:
							redo();
							break;
						}
					}

				}
			}
		}
		wakeupOn(wakeupCondition);

	}
	
	protected void undo(){
		paper.undo();
	}
	protected void redo(){
		paper.redo();
	}

}
