package jp.ac.nagoya_cu.sda.paper.behavior;


import java.util.ArrayList;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import javax.media.j3d.*;
import javax.vecmath.*;

import jp.ac.nagoya_cu.sda.paper.*;
import jp.ac.nagoya_cu.sda.paper.shape.*;

public class solveCollisionBehavior extends Behavior {
	protected WakeupOnElapsedFrames wup = null;

	protected Paper paper = null;

	protected ArrayList<VertexPoint> oldVpRefs = new ArrayList<VertexPoint>();

	protected ArrayList<Point3d> oldVpGeometries = new ArrayList<Point3d>();

	private Shape3D shp = new Shape3D();
	private Shape3D shpError=new Shape3D();
	
	private class ReturnTriangle{
		Point3d point;
		Triangle triangle;
		Plane plane;
	}

	public solveCollisionBehavior(Paper paper, Bounds bounds) {
		wup = new WakeupOnElapsedFrames(0);
		this.paper = paper;

		setSchedulingBounds(bounds);

		shp.setPickable(false);
		shp.setCapability(Shape3D.ALLOW_GEOMETRY_WRITE);
		paper.addChild(shp);
		
		shpError.setPickable(false);
		shpError.setCapability(Shape3D.ALLOW_GEOMETRY_WRITE);
		Appearance ap=new Appearance();
		ap.setPointAttributes(new PointAttributes(4f,false));
		ap.setColoringAttributes(new ColoringAttributes(new Color3f(0,0,1),ColoringAttributes.FASTEST));
		ap.setLineAttributes(new LineAttributes(4f,LineAttributes.PATTERN_SOLID,true));
		shpError.setAppearance(ap);
		paper.addChild(shpError);

	}

	public void initialize() {
		wakeupOn(wup);
	}

	public void processStimulus(Enumeration arg0) {
		execute();
		wakeupOn(wup);
	}

	protected void execute() {
		
		//Map<VertexPoint,List<ConnectPoints>> cl=createConnectedLinesCache();
		
		updateConnectPoints(createConnectedLinesCache());
		updateConnectPoints(createConnectedLinesCache());
		updateConnectPoints(createConnectedLinesCache());
		
		//solvePiercing();
		//solvePiercing();


		//solveCaveIn();
		//solveCaveIn();
		
		//solveCross();
		
		paper.updateShape3D();

		setOldVertexPoint();

	}

	private Map<VertexPoint,List<Line>> createConnectedLinesCache(){
		Map<VertexPoint,List<Line>> map=new HashMap<VertexPoint,List<Line>>();
		for(VertexPoint vp:paper.getAllVertexPoints()){
			map.put(vp,new ArrayList<Line>());
		}
		for(Iterator<Plane>it=paper.getAllPlanes();it.hasNext();){
			Plane plane=it.next();
			for(ConnectPoints cp:plane.getAllConnectPointsArray()){
				List<Line> lpa=map.get(cp.getPointA());
				List<Line> lpb=map.get(cp.getPointB());
				lpa.add(cp);
				lpb.add(cp);
			}
		}
		for(Line line:paper.getAllLineArray()){
			List<Line> lpa=map.get(line.getPointA());
			List<Line> lpb=map.get(line.getPointB());
			lpa.add(line);
			lpb.add(line);
		}
		return map;
	}
	
	
	
	/**
	 * ʂ̌`ێ
	 *
	 */
	protected void updateConnectPoints(Map<VertexPoint,List<Line>> connectedLines){
		Map<VertexPoint,double[]> nextVertex = new HashMap<VertexPoint,double[]>();


		for(VertexPoint vp:paper.getAllVertexPoints()){
			List<Line> connects = connectedLines.get(vp);
			
			// e_ɉ͂v 
			Vector3d F = new Vector3d(); // 
			double K=1; //ol萔
			int clen=0;	// {̍v
			
			for(Line cp:connects){
				
				Vector3d vec = new Vector3d();
				VertexPoint vpa =cp.getAnotherPoint(vp); 

				vec.sub(vpa,vp);
				vec.normalize();
				
				vec.scale(K);
				
				// Ἀ_bNĂȂꍇ͔
				if(vpa.isNotLocked()){
					vec.scale(cp.getErrorMargin()/2);
				} else{
					vec.scale(cp.getErrorMargin());
				}

				//lȉ̗͖͂
				if(vec.length()>0.00){
					F.add(vec);
					clen++;
				}
			}
			
			if(clen>0){
				// ͂̍v{Ŋ
				F.scale(1d/clen);
				
				// ͂߁A𑁂߂
				F.scale(F.lengthSquared()*10+1.01);
			}
				
			// vpɗ͂āAFړxNgƂ
			F.add(vp);
			
			// ̒_ړȂ悤Aʂ̔zɒlۑ
			double[] nx=new double[3];
			F.get(nx);
			nextVertex.put(vp,nx);
		}
		
		for(VertexPoint vp:paper.getAllVertexPoints()){
			if(vp.isNotLocked()){
				vp.set(nextVertex.get(vp));
			}
		}
	}

	
	
	/**
	 * ʂ̂߂肱ݏ
	 * 
	 */
	protected void solveCaveIn() {

		//_̈ʒuobNAbv
		Map<VertexPoint,Point3d> newVp = new HashMap<VertexPoint,Point3d>();
		for (VertexPoint vp : paper.getAllVertexPoints()) {
			newVp.put(vp,new Point3d(vp));
		}

		List<Line> caveInLines = new ArrayList<Line>();
		HashMap<Line,List<ReturnTriangle>> caveInTrs = new HashMap<Line,List<ReturnTriangle>>(); 

		for (Iterator<Line> lns = paper.getAllLines(); lns.hasNext();) {
			Line line = lns.next();

			VertexPoint pStartRef = line.getPointA();
			VertexPoint pEndRef = line.getPointB();

			// ƂׂĂ̖ʂ̏Փ˔
			List<ReturnTriangle> trs=getAllCaveIn(pStartRef,pEndRef);
			if(trs.size()>0){
				caveInLines.add(line);
				caveInTrs.put(line,trs);
			}
		}
		
		//ǂ̒_ǂ̖ʂɂ߂荞񂾂̃f[^x[X쐬
		List<VertexPoint> caveInVps = new ArrayList<VertexPoint>();
		HashMap<VertexPoint,List<Triangle>> VpTrMap = new HashMap<VertexPoint,List<Triangle>>();
		for(Line line:caveInLines){
			VertexPoint crrVpA=line.getPointA();
			VertexPoint crrVpB=line.getPointB();
			Point3d bfrVpA=getOldVertexGeometry(line.getPointA());
			Point3d bfrVpB=getOldVertexGeometry(line.getPointB());
			if(bfrVpA == null || bfrVpB == null){
				continue;
			}
			
			for(ReturnTriangle crrRTr:caveInTrs.get(line)){
				Triangle crrTr=crrRTr.triangle;
				Triangle bfrTr=createOldTriangle(crrTr);
				if(bfrTr==null){
					continue;
				}
				
				if(line.contain((VertexPoint)crrTr.p0) ||
						line.contain((VertexPoint)crrTr.p1) ||
						line.contain((VertexPoint)crrTr.p2)){
					continue;
				}
				
//				LineArray g=new LineArray(2,LineArray.COORDINATES);
//				g.setCoordinate(0,line.getPointA());
//				g.setCoordinate(1,line.getPointB());
//				shpError.addGeometry(g);
				
				VertexPoint caveInVp=null;
				if(crrTr.isRightSide(crrVpA) != bfrTr.isRightSide(bfrVpA)){
					caveInVp=crrVpA;
				}else if(crrTr.isRightSide(crrVpB) != bfrTr.isRightSide(bfrVpB)){
					caveInVp=crrVpB;
				} else {
//					// ǂ̓_߂荞񂾂킯ł͂ȂƂ
//					Plane plane=crrRTr.plane;
//					double dist=Double.MAX_VALUE;
//					Point3d pfrom=crrRTr.point;
//					Line closeline=null;
//					//ł߂Line𓾂
//					for(Line ln:plane.getPlaneGeometry().getAllLine()){
//						if(ln.distance(pfrom) < dist){
//							dist=ln.distance(pfrom);
//							closeline=ln;
//						}
//					}
//					//ړxNg
//					Vector3d v=new Vector3d(closeline.nearestPoint(pfrom));
//					v.sub(pfrom);
//					
//					newVp.get(crrVpA).add(v);
//					newVp.get(crrVpB).add(v);
					continue;
				}
				
				if(!caveInVps.contains(caveInVp)){
					caveInVps.add(caveInVp);
					VpTrMap.put(caveInVp,new ArrayList<Triangle>());
				}
				VpTrMap.get(caveInVp).add(crrTr);
			}
		}
		
		//߂荞񂾓_̍svZ
		for(VertexPoint vp:caveInVps){
			List<Triangle> trs=VpTrMap.get(vp);
			
			Point3d pfathest=null;
			double dist=-1;
			//łՓ˖ʂ擾
			for(Triangle tr:trs){
				Point3d p=tr.getClosestPoint(vp);
				if(p.distanceSquared(vp)>dist){
					dist=p.distanceSquared(vp);
					pfathest=p;
					
					//ʂ̓ֈړ
					pfathest=moveLittle(pfathest,tr.circumcenter(),0.001);
				}
			}
			if(pfathest!=vp){
				newVp.get(vp).set(moveTo(newVp.get(vp),pfathest,0.00001));
				
//				PointArray g=new PointArray(1,PointArray.COORDINATES);
//				g.setCoordinate(0,pfathest);
//				shpError.addGeometry(g);
//				
				System.out.println("CaveIn! ");
			}
		}

		for(VertexPoint vp:paper.getAllVertexPoints()){
			vp.set(newVp.get(vp));
		}
	}
	
	private List<ReturnTriangle> getAllCaveIn(Point3d p1, Point3d p2) {
		// ƂׂĂ̖ʂ̏Փ˔
		List<ReturnTriangle> trs = new ArrayList<ReturnTriangle>();
		for (Iterator<Plane> it = paper.getAllPlanes(); it.hasNext();) {
			Plane plane = it.next();
			for (Triangle tr : plane.getPlaneGeometry().getTriangleList()) {
				Point3d p = tr.intersectSegmentPoint(p1, p2);

				// Փ˂ĂȂA܂͏Փ˓_ɂ߂ꍇ͏XLbv
				if (p == null
						|| p.distance(tr.getClosestPointOnSegments(p)) < 1e-5) {
					continue;
				}

				// Op`܂łꍇXLbv
				if(tr.getClosestPoint(p1).distance(p1) < 1e-5 &&
						tr.getClosestPoint(p2).distance(p2) < 1e-5){
					continue;
				}

				ReturnTriangle rtr=new ReturnTriangle();
				rtr.point=p;
				rtr.triangle=tr;
				rtr.plane=plane;
				trs.add(rtr);
			}
		}
		return trs;
	}


	protected void solveCross() {

		//_̈ʒuobNAbv
		Map<VertexPoint,Point3d> newVp = new HashMap<VertexPoint,Point3d>();
		for (VertexPoint vp : paper.getAllVertexPoints()) {
			newVp.put(vp,new Point3d(vp));
		}

		List<Line> caveInLines = new ArrayList<Line>();
		HashMap<Line,List<ReturnTriangle>> caveInTrs = new HashMap<Line,List<ReturnTriangle>>(); 

		for (Iterator<Line> lns = paper.getAllLines(); lns.hasNext();) {
			Line line = lns.next();

			VertexPoint pStartRef = line.getPointA();
			VertexPoint pEndRef = line.getPointB();

			// ƂׂĂ̖ʂ̏Փ˔
			List<ReturnTriangle> trs=getAllCaveIn(pStartRef,pEndRef);
			if(trs.size()>0){
				caveInLines.add(line);
				caveInTrs.put(line,trs);
			}
		}
		
		for(Line line:caveInLines){
			VertexPoint crrVpA=line.getPointA();
			VertexPoint crrVpB=line.getPointB();
			Point3d bfrVpA=getOldVertexGeometry(line.getPointA());
			Point3d bfrVpB=getOldVertexGeometry(line.getPointB());
			if(bfrVpA == null || bfrVpB == null){
				continue;
			}
			
			for(ReturnTriangle crrRTr:caveInTrs.get(line)){
				Triangle crrTr=crrRTr.triangle;
				Triangle bfrTr=createOldTriangle(crrTr);
				if(bfrTr==null){
					continue;
				}
				
				if(line.contain((VertexPoint)crrTr.p0) ||
						line.contain((VertexPoint)crrTr.p1) ||
						line.contain((VertexPoint)crrTr.p2)){
					continue;
				}

				if(crrTr.isRightSide(crrVpA) != bfrTr.isRightSide(bfrVpA)){
					newVp.get(crrVpA).set(bfrVpA);
				}else if(crrTr.isRightSide(crrVpB) != bfrTr.isRightSide(bfrVpB)){
					newVp.get(crrVpB).set(bfrVpB);
				} else {
					newVp.get(crrVpA).set(bfrVpA);
					newVp.get(crrVpB).set(bfrVpB);
				}

				newVp.get(crrTr.p0).set(bfrTr.p0);
				newVp.get(crrTr.p1).set(bfrTr.p1);
				newVp.get(crrTr.p2).set(bfrTr.p2);

				System.out.println("Cross!!");
			}
		}

		for(VertexPoint vp:paper.getAllVertexPoints()){
			vp.set(newVp.get(vp));
		}
	}

	/**
	 * ʂ̓˂
	 * 
	 */
	protected void solvePiercing() {

		//_̈ʒuobNAbv
		Map<VertexPoint,Point3d> newVp = new HashMap<VertexPoint,Point3d>();
		for (VertexPoint vp : paper.getAllVertexPoints()) {
			newVp.put(vp,new Point3d(vp));
		}

		List<VertexPoint> intersectedVp=new ArrayList<VertexPoint>();
		Map<VertexPoint,List<Triangle>> VpTrMap=new HashMap<VertexPoint,List<Triangle>>(); 
		
		// Փ˔_
		List<Point3d> _pviewlist=new LinkedList<Point3d>();
		
		for (Iterator<Plane> it = paper.getAllPlanes(); it.hasNext();) {
			Plane plane = it.next();
			
			for(Triangle crrTr:plane.getPlaneGeometry().getTriangleList()){
				
				Triangle bfrTr=createOldTriangle(crrTr);
				if(bfrTr == null){
					continue;
				}
				
				//Փ˔_𐶐
				List<Point3d> pNew=createSensorPoint(crrTr);
				List<Point3d> pOld=createSensorPoint(bfrTr);
				List<VertexPoint> pSrc=createSensorPointSrc(crrTr);
				
				//ׂĂ̓_ƂׂĂ̖ʂ𔻒肷
				for(int i=0;i<pNew.size();i++){
					Point3d p1=pNew.get(i);
					Point3d p2=pOld.get(i);
					VertexPoint src=pSrc.get(i);
					
					_pviewlist.add(new Point3d(p1));
	
					//ׂĂ̖ʂƗ\
					List<Triangle> trs=getAllPiercing(p1,p2,plane);
					if(trs.size()>0){
						//intersectedPlaneList.add(plane);
						if(!intersectedVp.contains(src)){
							intersectedVp.add(src);
							VpTrMap.put(src,new ArrayList<Triangle>());
						}
						VpTrMap.get(src).addAll(trs);
//						PointArray g=new PointArray(1,PointArray.COORDINATES);
//						g.setCoordinate(0,p1);
//						shpError.addGeometry(g);
					}
				}
			}

		}

		if (_pviewlist.size() > 0) {
			PointArray geometry = new PointArray(_pviewlist.size(),	PointArray.COORDINATES);
			Point3d[] pl = new Point3d[_pviewlist.size()];
			_pviewlist.toArray(pl);
			geometry.setCoordinates(0, pl);
			shp.setGeometry(geometry);
		}
		
		//Փ˂Ă_͏Փ˖ʂɈԋ߂Ƃ֖߂
		for(VertexPoint vp:intersectedVp){
			List<Triangle> trs=VpTrMap.get(vp);
			
			Point3d pfathest=null;
			double dist=-1;
			//łՓ˖ʂ擾
			for(Triangle tr:trs){
				Point3d p=tr.getClosestPointInPlane(vp);
				if(p.distanceSquared(vp)>dist){
					dist=p.distanceSquared(vp);
					pfathest=p;
				}
			}
			if(pfathest!=vp){
				Point3d newPt=moveTo(vp,pfathest,0.0001);
				newVp.get(vp).set(newPt);
				System.out.println("Piercing! ");
			}
		}
		
		for(VertexPoint vp:intersectedVp){
			vp.set(newVp.get(vp));
		}
	}

	private Point3d moveTo(Point3d pFrom,Point3d pTo,double over){
		Vector3d d=new Vector3d();
		d.sub(pTo,pFrom);
		d.scaleAdd((over+d.length())/d.length(),pFrom);
		return new Point3d(d);
	}
	
	private Point3d moveLittle(Point3d pFrom, Point3d pTo, double scale) {
		Point3d pTmp = new Point3d();
		pTmp.sub(pTo, pFrom);
		pTmp.scale(scale);
		pTmp.add(pFrom);
		return pTmp;
	}

	private List<Point3d> createSensorPoint(Triangle tr){
		Point3d[] ps={tr.p0,tr.p1,tr.p2,tr.p0,tr.p1,tr.p2};
		Point3d pCenter=tr.circumcenter();
		List<Point3d> pl=new ArrayList<Point3d>();
		for(int i=0;i<3;i++){
//			Point3d p=moveLittle(ps[i],pCenter,1/20d);
			pl.add(ps[i]);
			pl.add(moveLittle(ps[i],pCenter,1/20d));
			pl.add(moveLittle(ps[i],pCenter,5/11d));
//			pl.add(moveLittle(p,    ps[i+1],5/11d));
//			pl.add(moveLittle(p,    ps[i+2],5/11d));
		}
		return pl;
	}
	private List<VertexPoint> createSensorPointSrc(Triangle tr){
		Point3d[] ps={tr.p0,tr.p1,tr.p2};
		List<VertexPoint> pl=new ArrayList<VertexPoint>();
		for(int i=0;i<ps.length;i++){
			for(int j=0;j<3;j++){
				pl.add((VertexPoint)ps[i]);
			}
		}
		return pl;
	}
	

	/**
	 * ݂̓_ɂāAOƂ͗\̊֌WقȂʂ擾
	 * @param crrPt _̌ݒn
	 * @param beforePt _̑Öʒu
	 * @param extPlane 肩珜OPlane
	 * @return ʒu֌WقȂTriangle
	 */
	private List<Triangle> getAllPiercing(Point3d crrPt,Point3d beforePt,Plane extPlane){
		List<Triangle> trs=new ArrayList<Triangle>();
		//ׂĂPlaneƗ\
		for(Iterator<Plane> it=paper.getAllPlanes();it.hasNext();){
			Plane plane=it.next();
			
			if(plane == extPlane){
				continue;
			}
			
			//Plane\邷ׂĂTriangleƗ\
			for(Triangle tr:plane.getPlaneGeometry().getTriangleList()){
				
				//O̒lTriangle𐶐
				Triangle oldTr=createOldTriangle(tr);
				if(oldTr==null){
					continue;
				}
				
				//ŐȌꍇ̓XLbv
				if(!tr.isInside(crrPt) && !oldTr.isInside(beforePt)){
					continue;
				}
				//Oʂ̏ꍇ̓XLbv
				if(tr.isRightSide(crrPt) == oldTr.isRightSide(beforePt)){
					continue;
				}
				trs.add(tr);
				
			}
		}
		return trs;
	}
	
	
	private Triangle createOldTriangle(Triangle tr){
		Point3d po0 = getOldVertexGeometry((VertexPoint) tr.p0);
		Point3d po1 = getOldVertexGeometry((VertexPoint) tr.p1);
		Point3d po2 = getOldVertexGeometry((VertexPoint) tr.p2);
		if(po0 == null || po1 == null || po2 == null){
			return null;
		}else{
			Triangle oldTr=new Triangle(po0,po1,po2);
			return oldTr;
		}
	}

	protected void setOldVertexPoint() {
		oldVpRefs = new ArrayList<VertexPoint>(paper.getAllVertexPoints());

		// 傫Ⴄꍇ͒
		while (oldVpRefs.size() < oldVpGeometries.size()) {
			oldVpGeometries.remove(0);
		}
		while (oldVpRefs.size() > oldVpGeometries.size()) {
			oldVpGeometries.add(new Point3d());
		}

		for (int i = 0; i < oldVpRefs.size(); i++) {
			Point3d po = oldVpGeometries.get(i);
			Point3d pn = oldVpRefs.get(i);
			if (po.distanceSquared(pn) > 1e-10) {
				po.set(pn);
			}
		}
	}

	/**
	 * O̒_̒lԂ
	 * 
	 * @param vp _\IuWFNg̎Q
	 * @return ̃IuWFNgQƂ̑O̒lBIuWFNgO񑶍݂ĂȂnullB
	 */
	protected Point3d getOldVertexGeometry(VertexPoint vp) {
		int index = oldVpRefs.indexOf(vp);
		if (index >= 0) {
			return oldVpGeometries.get(index);
		} else {
			return null;
		}
	}
}
