package jp.ac.nagoya_cu.sda.paper.shape;


/**
 * ܂ځA؂ڂŋ؂ꂽ
 */

/**
 * @author yousuke
 *
 */

import java.util.Arrays;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;

import javax.media.j3d.*;
import javax.vecmath.*;

import jp.ac.nagoya_cu.sda.paper.ConnectPoints;
import jp.ac.nagoya_cu.sda.paper.FoldingLine;
import jp.ac.nagoya_cu.sda.paper.Line;
import jp.ac.nagoya_cu.sda.paper.NormalRender;
import jp.ac.nagoya_cu.sda.paper.PlaneGeometry;
import jp.ac.nagoya_cu.sda.paper.VertexPoint;


public class Plane extends OrigamiShape {
	protected PlaneGeometry planegeometries = null; // ʂ̕ӂi[
	protected ConnectPoints[] cps = null;

	protected Shape3D rightside = null;	// \ʂ̃|Si[
	protected Shape3D backside = null;	// ʂ̃|Si[
	
	private Shape3D _normalshape=null;
	private Shape3D _connectshape=null;
	private BranchGroup _bg=null;
	
	private boolean isDebug=false;

	
	// ӂ̏W܂肩ʂ
	public Plane(PlaneGeometry ln) {
		this.planegeometries = ln;
		this.cps=createConnectPoints(ln);
		createShape(this);
		_debugCreateShape();
	}

	private ConnectPoints[] createConnectPoints(PlaneGeometry pg) {
		List<VertexPoint> vps=Arrays.asList(pg.getAllVertexPoints());
		
		//d
		HashSet<VertexPoint> _listvp=new HashSet<VertexPoint>();
		for(int i=0;i<vps.size();i++){
			_listvp.add(vps.get(i));
		}
		VertexPoint[] newvps=new VertexPoint[_listvp.size()];
		_listvp.toArray(newvps);
		
		//_ԂɃol𒣂
		LinkedList<ConnectPoints> listcp=new LinkedList<ConnectPoints>();
		for(int i=0;i<newvps.length;i++){
			VertexPoint pstart=newvps[i];
			
			for(int j=i+1;j<newvps.length;j++){
				VertexPoint pend=newvps[j];

				boolean flag=false;
				
				//łɒ_ԂLineǂ
				for(Line line:pg.getAllLine()){
					if(line.contain(pstart) && line.contain(pend)){
						flag=true;
						break;
					}
				}
				if(!flag){
					listcp.add(new ConnectPoints(pstart,pend));
				}
			}
		}

		ConnectPoints[] cps=new ConnectPoints[listcp.size()];
		listcp.toArray(cps);

		//System.out.println("ConnectPoints "+vps.length+" "+newvps.length+" "+cps.length);

		return cps;
	}

	public ConnectPoints[] getAllConnectPointsArray() {
		return this.cps;
	}

	public PlaneGeometry getPlaneGeometry() {
		return this.planegeometries;
	}

	// _z񂩂|S
	protected void createShape(Group gr){
		rightside = createDefaultShape();
		backside = createDefaultShape();

		gr.addChild(rightside);
		gr.addChild(backside);
	
	}
	
	private Shape3D createDefaultShape(){
		Shape3D shp = new Shape3D();
		shp.setCapability(Shape3D.ALLOW_GEOMETRY_READ);
		shp.setCapability(Shape3D.ALLOW_GEOMETRY_WRITE);
		shp.setCapability(Shape3D.ALLOW_APPEARANCE_READ);
		shp.setCapability(Shape3D.ALLOW_APPEARANCE_WRITE);
		return shp;
	}

	protected void setGeometry() {
			GeometryArray geometry = planegeometries.getGeometry();
			rightside.setGeometry(geometry);
			backside.setGeometry(geometry);
	}
	
	// |S𒸓_ɍ킹
	public void update() {
		setGeometry();
		_debugSetGeometry();
	}

	/**
	 * ^ꂽ_ł܂Ԃ
	 */
	public FoldingLine getFarthestFoldingLine(Point3d point) {
		double distance = Double.MIN_VALUE;
		FoldingLine fathestln=null;
		for(Line ln:planegeometries.getAllLine()){
			double d=ln.distance(point);
			if(ln instanceof FoldingLine && distance < d){
				distance=d;
				fathestln=(FoldingLine)ln;
			}
		}
		return fathestln;
	}

	/**
	 * ^ꂽ_ł߂܂Ԃ
	 */
	public FoldingLine getNearestFoldingLine(Point3d point) {
		double distance = Double.MAX_VALUE;
		FoldingLine closestln=null;
		for(Line ln:planegeometries.getAllLine()){
			double d=ln.distance(point);
			if(ln instanceof FoldingLine && distance > d){
				distance=d;
				closestln=(FoldingLine)ln;
			}
		}
		return closestln;
	}

	public void setRightsideAppearance(Appearance ap){
		rightside.setAppearance(ap);
	}
	public Appearance getRightsideAppearance(){
		return rightside.getAppearance();
	}
	public void setBacksideAppearance(Appearance ap){
		backside.setAppearance(ap);
	}
	public Appearance getBacksideAppearance(){
		return backside.getAppearance();
	}
	public Shape3D getShape(){
		return rightside;
	}

	
	private void _debugSetGeometry(){
		if(isDebug){
			NormalRender nr=new NormalRender((GeometryArray)rightside.getGeometry(), 0.2f);
			this._normalshape.setGeometry(nr.getLineArray());
			
			ConnectPoints[] listcp=this.cps;
			LineArray lines=new LineArray(listcp.length*2, LineArray.COORDINATES);
			int c=0;
			for(int i=0;i<listcp.length;i++){
				lines.setCoordinate(c+0,listcp[i].getPointA());
				lines.setCoordinate(c+1,listcp[i].getPointB());
				c+=2;
			}
			this._connectshape.setGeometry(lines);
		}
	}
	private void _debugCreateShape(){
		if(isDebug){
			this._normalshape=createDefaultShape();
			this._normalshape.setAppearance(createLineAppearance(new Color3f(1,1,1),1));
			
			this._connectshape=createDefaultShape();
			this._connectshape.setAppearance(createLineAppearance(new Color3f(1,1,0),3));
			this._connectshape.getAppearance().getLineAttributes().setLinePattern(LineAttributes.PATTERN_DASH);
			
			this._bg=new BranchGroup();
			_bg.setPickable(false);
			_bg.addChild(_normalshape);
			_bg.addChild(_connectshape);
			this.addChild(_bg);
		}
		
	}

	protected Appearance createLineAppearance(Color3f color,float width) {
		Appearance ap = new Appearance();

		ColoringAttributes ca = new ColoringAttributes();
		ca.setColor(color);
		ap.setColoringAttributes(ca);
		
		LineAttributes lattr = new LineAttributes();
		lattr.setLineWidth(width);
		ap.setLineAttributes(lattr);
		return ap;
	}
	

}
