package jp.ac.nagoya_cu.sda.paper.shape;

import javax.media.j3d.*;
import javax.vecmath.Color3f;
import javax.vecmath.Vector3d;

import jp.ac.nagoya_cu.sda.paper.VertexPoint;

import com.sun.j3d.utils.geometry.Sphere;

public class PointShape extends OrigamiShape {
	protected VertexPoint vp = null;

	protected Sphere shape = new Sphere(1, Sphere.GENERATE_NORMALS
			| Sphere.ENABLE_GEOMETRY_PICKING
			| Sphere.ENABLE_APPEARANCE_MODIFY, 8);;

	protected TransformGroup tg = new TransformGroup();

	protected Transform3D t3d = new Transform3D();

	protected Vector3d vec = new Vector3d();

	public PointShape(VertexPoint vp) {
		vp.setShape(this);
		this.vp = vp;

		setGeometry(vp);
		setAppearance(createAppearance(new Color3f(0, 0, 0), false));
		setVisible(false);

		tg.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
		tg.addChild(shape);
		this.addChild(tg);
	}

	public void setGeometry(VertexPoint vp) {
		vec.set(vp);
		t3d.set(vec);
		t3d.setScale(0.02);
		tg.setTransform(t3d);
	}

	public void setAppearance(Appearance ap) {
		shape.setAppearance(ap);
	}

	public Appearance getAppearance() {
		return shape.getAppearance();
	}

	public static Appearance createAppearance(Color3f color, boolean isVisible) {
		Appearance ap = new Appearance();

		ColoringAttributes ca = new ColoringAttributes();
		ca.setColor(color);
		ap.setColoringAttributes(ca);

		RenderingAttributes ra = new RenderingAttributes();
		ra.setVisible(isVisible);
		ap.setRenderingAttributes(ra);

		return ap;
	}

	public void update() {
		setGeometry(vp);
	}

	public VertexPoint getPoint() {
		return this.vp;
	}

	public void setVisible(boolean isVisible) {
		shape.getAppearance().getRenderingAttributes().setVisible(isVisible);
	}

	public boolean getVisible() {
		return shape.getAppearance().getRenderingAttributes().getVisible();
	}

}
